\documentclass{ctuthesis}
\usepackage[style=numeric, sorting=none, backend=biber]{biblatex}
\usepackage{csquotes}
\usepackage[ruled,vlined]{algorithm2e}
\usepackage{diagbox}

\addbibresource{sources.bib}

\usepackage[dvipsnames]{xcolor}
\usepackage{subcaption}
\usepackage{multirow}
\usepackage{makecell}


\ctusetup{
xdoctype = M,
xfaculty = F3,
mainlanguage = english,
titlelanguage = english,
title-english = {Modeling and optimization for traffic signal preemption for emergency vehicles using V2X communication},
title-czech = {Modelování a optimalizace pro zajištění prioritního průjezdu vozidel IZS světelně signalizovanou křižovatkou s využitím komunikace V2X},
department-english = {Department of Control Engineering},
department-czech = {Katedra řídicí techniky},
fieldofstudy-english={Cybernetics and Robotics},
fieldofstudy-czech={Kybernetika a robotika},
author = {Lukáš Pospíchal},
supervisor = {doc. Ing. Zdeněk Hurák, Ph.D.},
supervisor-address = {Katedra řídicí techniky FEL ČVUT,\\ Karlovo náměstí 13/E,\\
121 35 Praha 2,\\
Czech Republic},
day=21,
month = 5,
year = 2021,
keywords-czech = {prioritní průjezd vozidel, mikroskopická simulace dopravy, časově optimální řízení},
keywords-english = {traffic signal preemption, microscopic traffic simulation, time-optimal control},
specification-file = {zadani_en.pdf}
}

\definecolor{real}{RGB}{37,79,217}
\definecolor{virt}{RGB}{217,208,37}
\definecolor{amb}{RGB}{217,37,58}





\ctuprocess
\graphicspath{{./figures/}}

\begin{abstract-english}
With the introduction of modern approaches to traffic data collection come new possibilities for making traffic safer and less congested. It is viable to use the data to make our cities more spacious and productive through clever algorithms. 

In large cities, emergency vehicles have a significant impact on traffic. Furthermore, emergency vehicles have the highest rate of accidents, including fatal ones, thus making the inevitable responses of emergency vehicles safer, swifter while having as little impact on the surrounding urban traffic is of the utmost importance.

Traffic signal preemption is a common method to give preference to emergency vehicles at intersections, enabling vehicles that would be otherwise in the way of the emergency vehicle to clear the intersection before it reaches them. Even if proven by time, the methods currently in use are technologically outdated and have many drawbacks. The aim of this thesis is to propose a new, modern approach to traffic signal preemption for emergency vehicles.

This thesis proposes a new time-optimal traffic signal preemption algorithm designed to mitigate the drawbacks of existing preemption techniques using real-time traffic data collection and V2X communication technology. Even though the algorithm has been verified in traffic simulations, the current infrastructure is insufficient for real traffic deployment.
\end{abstract-english}

\begin{abstract-czech}
S příchodem moderních přístupů ke sběru dat z dopravy se otevírají dveře jeho využití ke zvyšování bezpečnosti dopravy a snižování její hustoty. S využitím chytrých algoritmů se nabízí možnost využít data z dopravy k tomu, aby naše města byla více prostorná a produktivní.

Ve velkých městech, mají vozidla ISZ velký vliv na dopravu. Navíc mají najvyšší pravděpodobnost nehod, včetně těch smrtených, a tak zvýšení bezpečnosti a zrychlení jejich výjezů a zároveň omezení jejich vlivu na okolní dopravu je velmi důležité.

Prioritní průjezd vozidel je běžnou metodou preference jistých vozidel na světelných křižovatkách, která umožňuje, aby vozidla stojící na světelné křižovatce ji opustila ještě před tím, než k ní dojede vozidlo IZS. Přestože existující přístupy jsou prověřený časem, jsou také velmi technologicky zastaralé a mají spustu nedostatků. Cílem této práce je návrh moderní metody prioritního průjezdu vozidel IZS na světelných křižovatkách. 

Tato práce popisuje návrh časově optimálního algoritmu pro prioritní průjezd vozidel IZS, který potlačuje nedostatky metod existujících za pomoci sběru dopravnách dat v reálném čase a V2X kominikační technologie. Přestože tato metoda byla simulačně otestována, na její nasazení do reálného provozu zatím existující infrastruktura nestačí.
\end{abstract-czech}

\begin{thanks}
I wish to thank primarily my supervisor doc. Hurák, for this great opportunity to immerse myself into such an interesting and rich topic. Secondly I would like to thank all my family and friends for their emotional support, and in case of some even financial. Namely I would like to thank in no order of no preference, thus alphabetically, my lovely mother Eva, her solid husband Jiří, my wise father Jiří and my amazing girlfriend Klára, who suffered from my studies the most.

Thank you all.
\end{thanks}

\begin{declaration}
I declare that this work is all my own work
and I have cited all sources I have used in
the bibliography.\\
Prague, \ctufield{day}.~\monthinlanguage{main}~\ctufield{year}
\end{declaration}


\begin{document}
\shorthandoff{-}
\maketitle

\chapter{Introduction}
\label{intro}

\section{Motivation}

In most urban environments, it is common to witness an \textit{emergency vehicle} (EV), e.g. an ambulance, a police car or a fire engine with its emergency light signal and siren active, rushing to its assigned accident site. It often includes going through a \textit{traffic light controlled junction} (TLJ). The typical behaviour of vehicles in the EV's path is to slow down, approach the side of the road and let the EV pass. Other vehicles give right-of-way to the EV. The EV can break many standard traffic rules. In Czechia and other EU countries, EVs can run red lights, overtake on the right, and overtake on the left, where such manoeuvres are forbidden for regular traffic\autocite{Bieker:Safety}.

While the safety of participants in traffic is of the utmost importance, minimising the response time of EVs also very important. Furthermore, the effect EVs have on traffic is also often investigated since it is not uncommon to have many active EVs within a city, each having the potential to restrict traffic in a given direction temporarily. Thus, the possibility of resulting traffic jams exists.

A common approach in tackling the issues mentioned above is to employ \textit{traffic signal preemption} (TSP). A scheme will give a green signal to any traffic ahead of an EV while restricting any traffic that could collide with an EV or slow it down. Doing so allows the EV a free passage through the TLJ. There are various methods to tackle this problem using various communication, computation, and conceptual strategies\autocite{Methods}. Most of the existing methods will be generalised in this thesis and differentiated by selected characteristics. Moreover, some characteristics (e.g. methods of communication) I will omit entirely.

It should be noted that TSP is not the only strategy commonly used to make EV responses safer and more efficient. There exists another widespread group of methods collectively labelled as \textit{emergency vehicle route optimisation}. It is not the focus of this thesis, however.

\section{Existing methods}

\subsection{No traffic signal preemption}
As stated before, when EVs approach TLJs without any TSP capability, EV drivers often need to make use of their special permissions to run red lights or, in case there are vehicles already halting at the red light by the time the EV approaches the TLJ, they need to overtake through the opposite direction lane. Such behaviour is hazardous, however, as EVs have a high chance of accidents\autocite{Burke}, and most of those happen at intersections, specifically, as a result of running red lights\autocite{Bieker:Safety}. Thus more sophisticated methods are needed.



\subsection{Distance-based (polygon) traffic signal preemption}

\begin{figure}[h]
\centering
\resizebox{\linewidth}{!}{\input{figures/distance_based1.eps_tex}}
\caption{Distance-based preemption}
\end{figure}

The most widespread variation of TSP in Czechia is one, where for each incoming road of a TLJ, there is a distance $d_\mathrm{p}$ within which an EV detection triggers a preemption signal sequence in the respective direction of traffic. 

This approach is often called a polygon preemption, as the distances (generally a few hundreds of meters) in all incoming directions form a polygon around the intersection. This static polygon is manually designed and optimised for each intersection by an experienced traffic engineer.

In the nomenclature of \citeauthor{Methods}, this is labeled as a passive defined-area-based green light preemption.

This approach can lead to unnecessarily long green phases for the EV and red phases for other vehicles, leading to the formation of jams. This is the main argument against this approach and, together with the problematic polygon design, is the main reason for its limited use.



\subsection{Adaptive polygon traffic signal preemption}
\begin{figure}[h]
\centering
\resizebox{\linewidth}{!}{\input{figures/distance_based2.eps_tex}}
\caption{Adaptive polygon preemption}
\end{figure}

Another more advanced approach aims to mitigate the disadvantages of the distance-based method by changing the polygon shape using real-world traffic information. Such data can take the form of historical data aggregate, induction loop feedback, traffic density estimates, etc. For more details on the individual types of active TSP, see the summary by \citeauthor*{Methods}\autocite{Methods}.

\begin{figure}[h]
\centering
\resizebox{\linewidth}{!}{\input{figures/distance_based3.eps_tex}}
\caption{Queue discharge preemption}
\label{fig:QDM_preemption}
\end{figure}

An especially relevant method, queue discharge-based traffic signal preemption, has been developed by \citeauthor*{Vitek}\autocite{Vitek}. It uses the estimate of the number of vehicles halting due to red light at the TLJ ahead of the EV as well as information on position and velocity of the EV given to the signal plan controller via \textit{vehicle to infrastructure} (V2I) communication device to alter the size of the polygon in the direction of the EV, see Figure \ref{fig:QDM_preemption}.

This particular method is significantly relevant to this thesis due to its development in partnership with a Czech manufacturer of the necessary infrastructure\footnote{\url{https://www.herman.cz/}}, aiming for simple implementation on existing hardware and subsequent testing in real traffic.

\section{Objectives}

This thesis introduces a new simulation-driven method of time-optimal traffic signal preemption for emergency vehicle prioritisation at TLJs. This method takes advantage of integrating modern technologies in traffic data collection, which are currently being introduced. 

\begin{figure}[h]
\centering
\resizebox{\linewidth}{!}{\input{figures/distance_based4.eps_tex}}
\caption{Time-optimal traffic signal preemption}
\label{fig:TOP_preemption}
\end{figure}

The method, visualised in Figure \ref{fig:TOP_preemption}, comes in the form of an algorithm or procedure, which can compute the optimal time to start a traffic signal preemption sequence when an EV approaches the intersection using real-time data inputs and traffic simulations. Thanks to its design, it minimises the impact EV has on surrounding traffic while still retaining the desired properties of standard methods, namely minimal delay of the EV and its maximum safety.

In order to ensure the best results possible, an appropriate car-following model needs to be selected. The model is necessary to simulate the passage of EVs forward in time accurately. This selection is made through the use of model-fitting on data from real-world traffic.

An essential part of the algorithm is the cost function used to discriminate among possible preemption times. The selection of cost functions in traffic engineering is generally rarely an exact science, and thus, it is crucial to explain the reasoning behind the cost function used in the algorithm.

Lastly, the proposed method will be validated in SUMO, a popular traffic simulator where it will be compared to typical methods of preemption. Additionally, the interpretation of the results will take place, followed by a summary and overall conclusions.




\section{Outline}
This thesis divides into chapters based on their respective focus. 

Chapter \ref{intro} includes the introduction to the problem, a brief overview of existing methods, most notably the method by \citeauthor*{Vitek}, which is the precursor to this work. Then, the thesis states the objectives of this work and gives an outline of this thesis.

Chapter \ref{model} investigates how accurate car-following models can be in simulating traffic at intersections. The best model considered is selected for use throughout the rest of the thesis.

Chapter \ref{algorithm} follows the conception of a time-optimal traffic light preemption algorithm using real-time traffic data. It discusses its viability and offers possible solutions to some of its insufficiencies.

Chapter \ref{SUMO} describes the validation of the proposed algorithm in SUMO, a traffic simulator, and discusses the results.

Chapter \ref{conclusion} offers a summary of this thesis, includes interpretation of overall results and offers suggestions for future research.


\chapter{Car-following models}
\label{model}
 A car-following model is a system of differential equations describing the behaviour of a vehicle in one-lane traffic. The engineering community has developed various models, and their main idea is to mimic a driver following another vehicle. The driver usually wants to go as fast as possible while not taking unnecessary risks and following a desired distance from the leading vehicle.

Car-following models are generally feedback-controlled systems. Where a human driver would observe their surroundings and, based upon those observations, would either press the gas paddle or the brake paddle and, therefore, change the acceleration of the vehicle accordingly, in a car-following model, this role falls upon the acceleration function, whose inputs are state variables and various external inputs.

There exists a large number of car-following models with varying degree of complexity. The more complex a model is, generally, the more aspects of driving behaviour it can model. There always exists a trade-off between accuracy and complexity when it comes to car-following models. Therefore, we would like to use a model using enough parameters to be accurate but not too many to be too challenging to fit measured trajectories of actual vehicles.  

\section{Car-following models at intersections}
\label{models_at_intersections}
Out of the commonly used and acceptably simple models for traffic simulations, i.e.  Krauss\autocite{Krauss}, IDM\autocite{Treiber} and Wiedemann\autocite{Wiedemann}, IDM has already been determined to be the most accurate for simulating vehicles passing an intersection without stopping at a red light\autocite{Bieker:Intersections}.

Thus, we need to ask, can it also be used to simulate queue discharge effectively? This efficiency is, unfortunately, entirely subjective and depends on a specific goal. For this reason, the model is evaluated in terms of the estimated time it takes the last vehicle in queue to reach a pre-defined speed threshold.

Let us assume an EV approaches a TLJ, where several vehicles halt due to a red light. The least disruptive scheme for a preemptive algorithm would be to start the preemption signal at such a time that the EV smoothly joins the departing vehicles, passes the intersection, and then the regular traffic plan resumes. There are several caveats to this approach. We do not want to initialise the preemption too soon since it would lead to an unnecessary traffic halt in intersecting directions. We also do not wish to start the queue discharge too late, as that would delay the EV. 

For these reasons, the most critical metric for evaluating the performance of a car-following model, as it relates to queue discharge simulation, is the error in time the last vehicle in the queue reaches the desired speed. If this error is sufficiently small, then we can optimise over the preemption initialisation time.

\subsection{Intelligent Driver Model (IDM)}
IDM is one of the most straightforward collision-free time-continuous models. Nevertheless, its intuitive design and acceptable accuracy have made it very a popular model for traffic simulations. Its best properties include smooth transitions between driving modes and easily understandable physical interpretation of its parameters. Its acceleration function is
\begin{equation}
\dot{v} = a \left[1-\left(\frac{v}{v_0}\right)^\delta - \left( \frac{s^*\left(v,\Delta v \right)}{s}\right)^2\right],
\end{equation}
with desired distance
\begin{equation}
s^*\left(v, \Delta v \right) = s_0 + \mathrm{max}\left(0, vT + \frac{v\Delta v}{2\sqrt{ab}}\right)
\end{equation}
and desired speed $v_0$, bumper-to-bumper distance to the leading vehicle $s_0$, speed relative to the leading vehicle $\Delta v$, time headway $T$, comfortable acceleration and deceleration  $a$ and $b$ respectively. There is also an acceleration exponent $\delta$. It is, however, usually set to $\delta=4$. See \citetitle{Treiber}\autocite{Treiber} for more detailed information on IDM.

Please note that there is a strong case for restricting the backwards motion of vehicles for any car-following model used for queue discharge simulation. If IDM parameters are imprecise so that during the first iteration of the simulation $s^*/s > 1$ and $v \approx 0$, the vehicle will start reversing, shortening the bumper-to-bumper distance behind it and eventually causing all vehicles behind it to reverse as well. This behaviour is far from desired, and thus one can disable backwards motion in the model using
\begin{equation}
\frac{s^*}{s} > 1 \wedge v \leq 0 \implies v := 0, \, \dot{v} := \mathrm{max}\left(0, \dot{v}\right)
\end{equation}
after each step of the simulation. Additionally, restriction of reverse motion has real-world justification as well. If a human driver stops unusually close to a leading vehicle while stopping at a red light, they do not usually start reversing to correct the spacing. They wait for the leading vehicle to accelerate, and once the leading vehicle is sufficiently far away, they start to accelerate as well.

\begin{figure}[h]
\centering
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{IDM_SEP_POS.eps}
\caption{positions}
\end{subfigure}
\hfill
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{IDM_SEP_VEL.eps}
\caption{speeds}
\end{subfigure}
\caption{Queue discharge using IDM}
\label{fig:IDM_discharge}
\end{figure}

Lastly, as seen in Figure \ref{fig:IDM_discharge}, vehicles simulated using IDM never reach the speed of their leading vehicles, always cautiously moving slightly slower than their leaders. Luckily, there are a plethora of extensions to IDM to make it more accurate.

\subsection{Improved Intelligent Driver Model (IIDM)}
IIDM is given in \citetitle{Treiber}\autocite{Treiber} as an example of methods used to improve the accuracy of car-following models without adding new parameters. Thankfully,  IIDM enables all vehicles in a queue to reach saturation speed. Which is, of course, achieved by altering the acceleration function. The improved acceleration function is defined as
\begin{equation}
\dot{v} = \left\{ \begin{aligned}
v &\leq v_0: & \left\{  \begin{aligned}
z &\geq 1:& &a\left( 1 - z^2 \right)\\
z &< 1:& &a_{\mathrm{free}} \left( 1 - z^{\frac{2a}{a_{\mathrm{free}}}} \right) \\
\end{aligned} \right|\\
v &> v_0: & \left\{ \begin{aligned}
z &\geq 1:& &a_\mathrm{free} +a\left( 1- z^2\right)\\
z &<1:& &a_\mathrm{free}\\
\end{aligned}\right|
\end{aligned} \right| ,
\end{equation}
where 
\begin{equation}
a_\mathrm{free} = \left\{ \begin{aligned}
v &\leq v_0: & a \left[1-\left( \frac{v}{v_0}\right)^\delta \right]&\\
v &> v_0: & -b\left[ 1-\left(\frac{v_0}{v}\right)^{\frac{a\delta}{b}}\right]&
\end{aligned} \right| \text{, and } \, z=\frac{s^*}{s}.
\end{equation}
The parameters $v_0, s_0, T, a,b,s, \delta$ and the desired distance $s^*$ are defined identically and serve the same purpose as in the case of IDM. Again, more details can be gathered in \citetitle{Treiber}. 

Please note that in case $v=v_0$ and $z < 1$, the acceleration function is undefined. While in the real world, this condition is an unachievable edge case, for the purposes of numerical simulation, it is necessary to define a special case
\begin{equation}
\dot{v} = \lim_{a_\mathrm{free} \rightarrow 0^+} a_\mathrm{free}\left(1-z^{\frac{2a}{a_\mathrm{free}}} \right) = 0, \quad v = v_0 \text{ and } z<1,
\end{equation}
for the model, especially given the fact that computers evaluate expressions inside-out. Without this addition to the definition, any vehicle further from the leading vehicle than $s_0$, which reaches its desired speed $v_0$, would crash the simulation. Even with this addition, it is still possible to achieve floating-point errors since
\begin{equation}
\lim_{a_\mathrm{free}\rightarrow0^+}  z^{\frac{2a}{a_\mathrm{free}}} = \infty, \quad v \leq v_0 \text{ and } z<1.
\end{equation}
Thus special care should be taken to handle these special cases.

Additionally, arguments and solutions for restricting backward motion are identical to those of IDM.

\begin{figure}[h]
\centering
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{IIDM_SEP_POS.eps}
\caption{positions}
\end{subfigure}
\hfill
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{IIDM_SEP_VEL.eps}
\caption{speeds}
\end{subfigure}
\caption{Queue discharge using IIDM}
\label{fig:IIDM_discharge}
\end{figure}

As seen in Figure \ref{fig:IIDM_discharge}, vehicles simulated using IIDM can match the speed of their leading vehicles. Furthermore, the error in the velocity profile of the last vehicle in the queue is smallerr.

\subsection{Linear Queue Discharge Model (LQDM)}
While IIDM looks very promising, it is worth investigating whether a much simpler model could be used to simulate the queue discharge since IIDM is quite difficult to simulate numerically correctly. Its acceleration function is
\begin{equation}
\dot{v} = \left\{ \begin{aligned}
t &< t_\mathrm{start} + T_\mathrm{delay}: 0\\
t &\geq t_\mathrm{start} + T_\mathrm{delay}: a\left(1 - \frac{v}{v_0}\right)
\end{aligned} \right|, 
\end{equation}
where $t_\mathrm{start}$ is the time a leading vehicle starts accelerating, $T_\mathrm{delay}$ is a time a vehicle waits, after its leader starts accelerating, before starting accelerating itself, $a$ is maximum acceleration and $v_0$ is desired speed.

\begin{figure}[h]
\centering
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{LTI_SEP_POS.eps}
\caption{positions}
\end{subfigure}
\hfill
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{LTI_SEP_VEL.eps}
\caption{speeds}
\end{subfigure}
\caption{Queue discharge using LQDM}
\label{fig:LQDM_discharge}
\end{figure}

While this model does not meet the definition of a car-following model, it can be pretty useful to simulate queue discharge after switching to green light, as seen in Figure \ref{fig:LQDM_discharge}. It is, however, completely useless for other traffic scenarios at intersections since it requires all vehicles at $t=0$ to be almost stationary. It is of little usage for simulations, where vehicles have non-zero initial velocities. Also, estimating the values of the parameters ahead of the queue discharge for individual vehicles might be very challenging.

\section{Parameter fitting}
\subsection{Sequential fitting}
\label{sequential}
All parameters of the models simulated in \ref{models_at_intersections} have been fitted using \texttt{lsqcurvefit} function in MATLAB\autocite{MATLAB}. Parameters $\textbf{p}_\mathrm{model}$ of all vehicles in a given queue have been fitted sequentially, i.e. first vehicle was fitted first and then the second and so on. The function was used to minimise \textit{mean square error}(MSE) of simulated positions and speeds of a given vehicle. 
\begin{equation}
\textbf{p}_\mathrm{model}^* = \mathrm{argmin}\, \mathrm{MSE}\left(\begin{bmatrix}
\textbf{x}_\mathrm{sim} \left(\textbf{p}_\mathrm{model}\right) \\ 
\textbf{v}_\mathrm{sim} \left(\textbf{p}_\mathrm{model}\right)
\end{bmatrix}, \begin{bmatrix}
\textbf{x}_\mathrm{real}\\
\textbf{v}_\mathrm{real}
\end{bmatrix} \right),
\end{equation}
where $^*$ denotes optimality.

While IDM and IIDM had better performance when all vehicles were fitted simultaneously, it is more realistic to assume that the parameters of a leading vehicle cannot be affected by the trajectory of the following vehicle. The goal of fitting the parameters this way was to show how accurate these models can be if all vehicles pass perfect estimates of their parameters to the simulation before the queue discharge, i.e., how accurate the models can be given perfect conditions.

\begin{figure}[h]
\centering
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{SEP_ALL_VEH_X_RMSE.eps}
\caption{positions}
\end{subfigure}
\hfill
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{SEP_ALL_VEH_V_RMSE.eps}
\caption{speeds}
\end{subfigure}
\caption{Boxchart of root mean square error of simulated vehicles}
\label{fig:model_box_all}
\end{figure}

When using this parameter fitting method, optimal parameters were found for each model for 112 vehicles in 35 different queues from different lanes of two real-world TLJs. As seen in Figure \ref{fig:model_box_all}, the smallest  median fitting \textit{root mean square}(RMS) error for both positions and velocities has been achieved by LQDM. Furthermore, IIDM has been found to generate more accurate velocity profiles than IDM, which is the main idea behind IIDM.

\begin{figure}
\centering
\includegraphics[width=0.6\linewidth]{SEP_LAST_VEH_V_RMSE.eps}
\caption{Boxchart of root mean square error of velocities of last vehicles in their respective queues.}
\label{fig:model_box_last}
\end{figure}

As explained in \ref{model}, the most important metric is the velocity profile of the last vehicle in a queue. The boxchart of RMS errors of velocity profiles of the last vehicles in their respective queues is shown in Figure \ref{fig:model_box_last}. The error in time it takes a vehicle to reach saturation speed was not evaluated, as stated in \ref{model}, since it is not guaranteed that a real vehicle reaches the saturation speed, and thus, such metric would be meaningless. It is, however, strongly related to the accuracy of the velocity profile. While it is not guaranteed that minimising one minimises the other, minimising RMS error of the velocity profiles keeps the time difference of reaching saturation speed sufficiently small.

The LQDM fares best when it comes to velocity profiles of the last vehicles of queues, IIDM shows better performance over IDM, in this regard.



\subsection{Parameter averaging}
\label{averaging}
While it is important to see how well a model can be used for a queue discharge simulation, it can be argued that it is currently infeasible to expect vehicles to pass their model parameters estimates to the TLJ controller using \textit{vehicle to everything} V2X communication. Therefore, it makes sense to ask, how the models fare if model parameters of vehicles are estimated by the infrastructure. A possible scenario for such a system would use a computer vision system installed at the TLJ to gather data for individual lanes and vehicle types, and from those, it could assign an estimate of model parameters as soon as a vehicle enters the detection range. 

Given the fact that the available dataset is too limited to consider vehicle types, the same evaluation from \ref{sequential} was repeated, only this time the parameters of all vehicles passing the intersection using the same lane were averaged, thus emulating an estimate from historical data. Velocity profiles of queue discharge simulations of the same scenario as in \ref{model}, now using averaged parameters, can be seen in Figure \ref{fig:avg_discharge_vel}.

\begin{figure}[h]
\centering
\begin{subfigure}{0.3\linewidth}
\includegraphics[width=\linewidth]{IDM_AVG_VEL.eps}
\caption{IDM}
\end{subfigure}
~
\begin{subfigure}{0.3\linewidth}
\includegraphics[width=\linewidth]{IIDM_AVG_VEL.eps}
\caption{IIDM}
\end{subfigure}
~
\begin{subfigure}{0.3\linewidth}
\includegraphics[width=\linewidth]{LTI_AVG_VEL.eps}
\caption{LQDM}
\end{subfigure}
\caption{Velocity profiles of a queue with averaged parameters}
\label{fig:avg_discharge_vel}
\end{figure}

\begin{figure}[h]
\centering
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{AVG_ALL_VEH_X_RMSE.eps}
\caption{positions}
\end{subfigure}
\hfill
\begin{subfigure}{0.485\textwidth}
\includegraphics[width=\linewidth]{AVG_ALL_VEH_V_RMSE.eps}
\caption{speeds}
\end{subfigure}
\caption{Boxchart of root mean square error of simulated vehicles with averaged parameters}
\label{fig:avg_model_box_all}
\end{figure}

\begin{figure}
\centering
\includegraphics[width=0.6\linewidth]{AVG_LAST_VEH_V_RMSE.eps}
\caption{Boxchart of root mean square error of velocities of last vehicles in their respective queues}
\label{fig:avg_model_box_last}
\end{figure}

It is clear that the velocity profiles in Figure \ref{fig:avg_discharge_vel} perform worse, when the parameters are averaged, then using the optimal parameters for every vehicle. However, the fit is skewed due to the fact, that my dataset does not include information about the length of individual vehicles, which is the only absolutely static car-following model parameter, which is not dependent on the driver and would be easily accessible in the aforementioned hypothetical scenario with computer vision systems estimating the parameters. 

In the previous case, it did not matter that I did not have access to vehicle lengths, since the $l + s_0 = const$ for any optimal parameter fit, where $l$ is the length of the leading vehicle and $s_0$ is the desired bumper-to-bumper distance of the leading vehicle. However, with suboptimal parameters a new issue arises. If a vehicle stops too close behind a too short a vehicle, it may lead to the computed bumper-to-bumper distance $s<0$. Which can be interpreted as a collision and breaks the simulation.

To eliminate the possibility of having vehicles virtually colliding in the first step of the simulation, I adjusted $l = \mathrm{min}	\left( l,x_\mathrm{leader} - x - s_0 \right) $. This is a completely naive solution to the problem. Surely, more nuanced solution can be found. I do not believe it is necessary, however, since the unavailability of vehicle lengths is not a very realistic condition, given the assumption of having a modern position and velocity detection device at the TLJ or V2X communication capability.

Given the aforementioned limitations the absolute values shown in Figure \ref{fig:avg_model_box_all}, need to be read with scepticism. On the other hand, the relative performance of the investigated methods did not change, only the median errors of velocities of IDM and LQDM have moved closer to the error of IIDM, whose median RMS error has increased very little.

Curiously enough, as shown in Figure \ref{fig:avg_model_box_last}, the RMS erros of the last vehicles in their respective queues have decreased for all the models investigated. This result, again, has to be taken with a grain of salt, because I suspect the result is skewed by the lack of vehicle length information.

\section{Final thoughts on car-following model selection}
Given the simulations I ran using IDM, I do not find it to be particularly appealing for usage in queue discharge simulations. It does not simulate sufficiently accurate velocity profiles for the vehicles at the end of a queue. And since our main goal is to eventually reach the end of a queue at a time when all the cars have reached sufficiently high velocities, IDM should not be used. IIDM, on the other hand does produce sufficiently accurate results and unlike LQDM, whose results were in many cases even better, it can be used to simulate all one lane traffic before a TLJ, whereas LQDM can only be used to simulate the queue discharge with no initial velocities.

For these reasons I will use IIDM in the rest of the thesis for simulations of queue discharge and preemption.

Finally, I want to point out how surprisingly simple and accurate LQDM turned out to be. Even though, it might not be perfect for the use case of this thesis, it was by far the most accurate in simulating the positions of vehicles in any scenario I simulated.



\chapter{Time optimal traffic signal preemption algorithm}
\label{algorithm}
While queue discharge-based traffic signal preemption has been shown to be effective, as stated by \citeauthor*{Vitek}\autocite{Vitek} in their conclusions, it would be preferable to formulate the problem of finding the optimal preemption time using clearly defined optimisation techniques. This is the focus of this chapter.

\section{Assumptions}
\label{assumptions}
Let us start with assuming unrealistically ideal conditions, specifically pertaining to the data available to the traffic signal controller. Later, we will discuss how various limitations of these assumptions can be tackled in terms of formulation of the algorithm.

Therefore, let us assume an emergency vehicle sends a sign-in signal (This can be thought of as a signal telling the controller to start the preemption time computation) to the traffic light controller at time $t=0\, \mathrm{s}$. We can simulate its approach to, and crossing of the intersection  given these conditions:
\begin{enumerate}
\item \label{cond1} Knowledge of the velocities and positions of vehicles in the platoon ahead of the EV and the EV itself.
\item \label{cond2} Knowledge of the model parameters for all such vehicles and the EV for a selected car-following model.
\item \label{cond3} Knowledge of the default traffic light signal plan for the duration of approach and passage of the emergency vehicle.
\item \label{cond4} Knowledge of the constraints of the traffic light signal plan (minimum signal lengths etc.).
\end{enumerate}

\section{Simulation}
\label{simulation}
Using the assumptions in \ref{assumptions} and a correct selection of a car-following model, we can simulate the approach of the EV to the end of the vehicle platoon ahead. Figure \ref{fig:nopreemption} shows such simulation for the case of late preemption. We can see how the EV stops at a red light, while this is very unrealistic, since the EV would most surely overtake the vehicle ahead and cross the intersection through a red light in the real world, we do not need to model such behaviour, because both of these behaviours are undesirable from the point of view of our problem. Since the preemtion eliminates the necessity to run red lights by the EV, by disallowing overtaking and penalizing waiting, our algorithm will deem late preemption times very costly.

\begin{figure}[h]
\centering
\includegraphics[width=.9\textwidth]{figures/nopreemption_light_sim.pdf}
\caption{Simulation of an approach of an \textcolor{amb}{emergency} vehicle using IIDM with a signal plan with late preemption.}
\label{fig:nopreemption}
\end{figure}

On the other hand, early preemption times, example of which is shown in Figure \ref{fig:polygon}, should also be avoided. In the example simulation, we can see that the preemption had been initiated more than $30 \mathrm{s}$ before the EV entered the intersection. Surely, some of this time would have been better used, if traffic in intersecting directions was allowed and the preemption started when the EV was much closer to the intersection.

\begin{figure}[h]
\centering
\includegraphics[width=.9\textwidth]{figures/polygon_light_sim.pdf}
\caption{Simulation of an approach of an \textcolor{amb}{emergency} vehicle using IIDM with a preemption time $t_{p} = 0$ (dotted line).}
\label{fig:polygon}
\end{figure}


\section{Cost function}
\label{costfunction}
Understandably, both of the two extreme cases for preemption times in \ref{simulation} are undesirable, and the optimal time needs to exist somewhere in between the two extremes. Another observation, however, can help with the initial idea behind a way to design a preemption time cost function.

Suppose, the requested preemption time $t_\mathrm{p} = 0$, this will result in a traffic light signal plan where the EV receives a green signal as soon as  condition \ref{cond4} allows it. Given this, no other traffic light signal plan can cause  less deceleration. Let us define 
\begin{equation}
\label{eq:vstar}
V_\mathrm{min}^* = V_\mathrm{min}^0 = \mathrm{min} \left( \textbf{v}_\mathrm{emergency}(t, t_\mathrm{p}=0) \right),\\
\end{equation}
which is the highest achievable minimum velocity of the emergency vehicle for the duration of the simulation, i.e. $\nexists t_\mathrm{p} \geq 0: V_\mathrm{min}^{t_\mathrm{p}} > V_\mathrm{min}^*$, and
\begin{equation}
\label{eq:tmax}
t_\mathrm{p}^\mathrm{max} =  \frac{v_{\mathrm{des,emergency}}}{d_{0,\mathrm{emergency}}},\footnote{$v_{\mathrm{des,emergency}}$ denotes the desired speed of the EV and $d_{0,\mathrm{emergency}}$ its initial distance to the intersection in the context of the simulation}
\end{equation}
the upper limit of the interval upon which it is useful to search for
\begin{equation}
t_\mathrm{p}^* = \mathrm{max} \, t_\mathrm{p}: V_\mathrm{min}^{t_\mathrm{p}} = V_\mathrm{min}^*, \, t_\mathrm{p} \in \left[ 0, t_\mathrm{p}^\mathrm{max} \right],
\end{equation}
the latest preemption request signal time, which will not delay the emergency vehicle compared to immediate preemption at earliest possible time.

Finally, let us define cost function
\begin{equation}
C(t_\mathrm{p}) = \textcolor{OliveGreen}{C_1} + \textcolor{WildStrawberry}{C_2} = \textcolor{OliveGreen}{ \left( 1-\gamma \right) \left(1-\frac{t_\mathrm{p}}{t_\mathrm{p}^\mathrm{max}}\right) } + \textcolor{WildStrawberry}{\gamma \left(  1 - \frac{V_\mathrm{min}^{t_\mathrm{p}}}{ V_\mathrm{min}^*} \right)}, \, 0 < \gamma \ll 1,
\end{equation}
where the parameter $\gamma$ introduces a small slope to the regions where $\textcolor{WildStrawberry}{C_2} $ is constant, this enables reliable localization of $t_\mathrm{p}^*$, without the effect of floating point errors in the evaluation of $\textcolor{WildStrawberry}{C_2} $. We can see an example of a cost function $C(t)$ in Figure \ref{fig:lightcost}.

\begin{figure}[h]
\centering
\includegraphics[width=.9\textwidth]{figures/nopreemption_light_cost.pdf}
\caption{Cost function computed for the scenario in Figure \ref{fig:nopreemption}.}
\label{fig:lightcost}
\end{figure}

\section{Time optimal preemption algorithm}
Let us define the algorithm for the optimal preemption time $t_\mathrm{p}^*$ computation. Let us assume it has access to all the necessary resources available. The algorithm used to find $t_\mathrm{p}^*$ can be seen in Algorithm \ref{alg:t_opt}.

\begin{algorithm}[H]
\DontPrintSemicolon
$P(t_\mathrm{p}) \leftarrow$ signal plan with preemption in effect at time $t=t_\mathrm{p}$\;
$v(P(t_\mathrm{p})) \leftarrow$ simulated velocity profile of the EV if preemption sequence starts at $t_\mathrm{p}$\;
$v_\mathrm{des} \leftarrow$ desired speed of the EV\;
$d_0 \leftarrow$ initial distance of the EV\;
$t_\mathrm{left} \leftarrow$ initial time\;
$t_\mathrm{right} = t_\mathrm{p}^\mathrm{max} = t_\mathrm{left} + \frac{v_\mathrm{des}}{d_0}$ max preemption time\;
$\epsilon_\mathrm{min} \leftarrow$  termination difference\;

$V_\mathrm{min}^* = \mathrm{min}(v(P(0))$\;

$C(t_\mathrm{p}) = C(t_\mathrm{p}), v(P(t_\mathrm{p})), t_\mathrm{p}^\mathrm{max}, V_\mathrm{min}^*) \leftarrow$ preemption time cost function  

\While{$\left| t_\mathrm{right}-t_\mathrm{left} \right| \geq \epsilon_\mathrm{min}$}
{
	\If{$C(t_\mathrm{left}) < C(t_\mathrm{right})$}
	{
		$t_\mathrm{right} = \frac{t_\mathrm{right}+t_\mathrm{left}}{2}$\;
	}
	\Else
	{
		$t_\mathrm{step} = \frac{t_\mathrm{right}-t_\mathrm{left}}{2}$\;
		$t_\mathrm{left} = t_\mathrm{right}$\;
		$t_\mathrm{right} = \mathrm{max}\left( t_\mathrm{right} + t_\mathrm{step}, t_\mathrm{p}^\mathrm{max}\right)$\;
	}
}
\KwResult{$t_\mathrm{p}^* = t_\mathrm{left}$}
\caption{Optimal preemption time $t_\mathrm{p}^*$}
\label{alg:t_opt}
\end{algorithm}

The optimal preemption time $t_\mathrm{p}^*$ is then given to the traffic light signal plan controller to apply the signal plan $P(t_\mathrm{p})$. A simulation of an approach of an EV using the optimal preemption time can be seen in Figure \ref{}.

\begin{figure}[h]
\centering
\includegraphics[width=.9\textwidth]{p_opt_sim.pdf}
\caption{Simulation of an approach of an \textcolor{amb}{emergency} vehicle using IIDM with a preemption time $t_{p}^*$.}
\label{fig:t_opt}
\end{figure}

\subsection{Notes on the algorithm output}
It could be argued, it might be mode convenient to interpret the output in terms of preemption distance. That is, reshaping the polygon within which an EV would trigger the preemption. This, however, leads to the risk of rendering the preemption impossible to trigger at the right time. If the EV enters this computed region too late, it might be too late to trigger preemption in time. Thus it is better to trigger the preemption based upon time duration since EV sign-in. That is the advantage of having access to the default signal plan and its limitations. We can incorporate them into the simulation.


It should be noted that the algorithm itself does not alter the signal plan, it is only selecting one of the possible signal plans, the signal plan controller feels comfortable with. This makes the method as a whole less intrusive to the overall signal plan design. Where traffic engineers might feel uncomfortable allowing a new algorithm to control the signal plans of an intersection, allowing an algorithm to choose from a set of signal plans with predefined constraints should be well within their comfort zone.

\subsection{Real-world adjustments}
Let us discuss the adjustments we can make to the algorithm in order for it to be applicable to real-world traffic. Specifically, we need to address the unrealistically ideal assumption upon which the algorithm stands. It is not my intention to invent new traffic infrastructure technology. I aim to give examples of possible approaches, which would make the method introducible to the real world traffic.

Firstly, the assumption \ref{cond1} might seem too unrealistic at first. However, there exist commercial solutions for traffic data collection using computer vision (example being \href{https://datafromsky.com/}{DataFromSky}\footnote{url: \url{https://datafromsky.com/}}) and there is also the future potential of using V2X communication, for the purposes of each vehicle reporting the data to the infrastructure.

Secondly, same concepts could be used to satisfy assumption \ref{cond2}. However to find car-following model parameters from the limited time a vehicle spends in the range of the AI-powered detectors might be infeasible, thus I suggest using estimation over vehicle types through fitting to aggregated historical data. In the context of the V2X data collection route, each vehicle could be equipped with its own parameter estimator and reporting its output to the infrastructure.

Furthermore, assumptions \ref{cond3} and \ref{cond4} do not need any new technology introduced to be met.

In case of the use of computer vision in data gathering, we need to address the possibility of the detectors not having the range required to detect all vehicles in front of the EV at the time of sign-in. A naive solution would be to start the computation of the preemption after the EV enters the visual range of the detectors. Alternatively, having good estimates on the current traffic flow density of all the vehicle types would allow filling the area between the EV and the end of the visual range of the detectors with ``virtual'' vehicles and only then starting the algorithm.

Finally, there is no reason not to use the algorithm repeatedly (e.g. every second) until $t_\mathrm{p}^*$ with the intention to get more accurate result with each evaluation. This approach is more computationally intensive but the nature of the algorithm allows for strong parallelisation. Additionally, the fact that the method as a whole is very technologically demanding, making use of other computationally intensive technologies, makes the case for there being sufficient computation power available.  For the purposes of this thesis I call this approach the \textit{recomputation} method.


\chapter{Validation in SUMO}
\label{SUMO}

\section{Scenario}

\begin{figure}[h]
\centering
\includegraphics[width=\linewidth]{scenario.pdf}
\caption{Intersection scenario simulated in SUMO.}
\label{scenario}
\end{figure}

For the purposes of validating the preemption method proposed in Chapter \ref{algorithm},  a scenario was created using the traffic simulator SUMO\autocite{SUMO}. A snapshot taken from its graphical user interface running the scenario can be seen in Figure \ref{scenario}. In the snapshot, we can see blue passenger vehicles, yellow buses and an emergency vehicle approaching the junction from the west. Take note of the fact, that vehicles in front of the EV are in the process of forming a virtual middle lane for the EV to pass through. The light blue stripes represent lane area detectors, which are used to gather information about vehicles approaching the intersection.

The map consists of the four roads, each stretching $1\, \mathrm{km}$ away from the central intersection. Vehicles are randomly injected at the end of each road based on desired traffic flow density. Each of the incoming roads consist of two lanes, the left of which is dedicated for left turning vehicles and the right lane is dedicated for vehicles continuing straight and to the right. All the outgoing lanes consist of a single lane each.

In SUMO, EVs are simulated as vehicles of a special \textit{emergency}	vehicle class with a \textit{bluelight} device. Such vehicles are able to either overtake other vehicles through virtual middle lanes, or through the opposite direction lane, depending on the lane change model used. Having both functionalities simultaneously is not currently supported in SUMO. Of the two, I opted to use the functionality with the formation of virtual middle lanes, since it more closely resembles desired behaviour of other vehicles. Under the current functionality, vehicles in range of the bluelight device move to the right edge of their lane unless they occupy the leftmost lane, in which case, they move to the left. 

The vehicles in range of the bluelight device currently do not change their speed in reaction to the presence of the EV nor have the ability to give right of way to an EV running a red light when their traffic light signals green. Thus an EV crossing a TLJ with no method of preemption can have little to no effect on the surrounding traffic. One option to handle this would be not to use a blue light device at all and make the EV wait like all the other vehicles. This approach seems even more unrealistic though, and as such I implemented the former one.

\section{Implementation of traffic signal control in SUMO using TraCI}

SUMO itself has very limited options for the implementation of preemption algorithms. Traffic lights can be programmed to dynamically change signal plan phase durations within a predefined range based upon information from induction loops and the occupation of lane area detectors. For more sophisticated functionality one must use TraCI, a communication interface enabling on-line communication with the SUMO simulation. 

A TraCI instance is initialised within a Python script, it connects to a SUMO simulation and allows for precise control of the behaviour of objects in the simulation. There is a special class object defined by TraCI, namely \texttt{stepListener}, which automatically runs a given code every simulation step.Therefore, I created a child class of  \texttt{stepListener} called \texttt{Scheduler}, which functions as a central node of the traffic signal control for the intersection. \texttt{Scheduler} facilitates communication among various other classes, each systematically dedicated to a single subtask of traffic signal control. The interaction among these individual parts can be best explained using the schematic in Figure \ref{flowchart}

\begin{figure}[h]
\centering
\includegraphics[width=\linewidth]{flowchart.pdf}
\caption{Schematic of the functionality of \texttt{Scheduler} and other classes.}
\label{flowchart}
\end{figure}

\subsection{Functionality of \texttt{detector}}
Each of the eight lane area detectors in the simulation has an \texttt{detector} instance assigned by \texttt{scheduler}. Since it is also a child of the \texttt{stepListener} class, it is designed to keep tack of the vehicles in the  range of the detector, identify them, count them and request their positions and speeds from SUMO through TraCI.

\subsection{Functionality of \texttt{Ambulance}}
Whenever \texttt{Scheduler} detects an EV an instance of \texttt{Ambulance} is assigned to it. As a child of \texttt{stepListener} it requests position and speed of the EV from SUMO through TraCI every simulation step.

\subsection{Functionality of \texttt{TrafficLight}}
The primary function of \texttt{TrafficLight} is to increment the traffic signal plan on the intersection. Even though, this is normally handled natively by SUMO, the limitations on the traffic light signal plan (minimum phase lengths, insertion of yellow signal phase before preemption) made the automatic signal phase incrementation by SUMO very inconvenient. It required many requests on the current state of the signal plan to be made each simulation step, their subsequent interpretation and transformation to a more usable format, and then in the overwhelming majority of simulation steps, it was evaluated that no action is needed to be issued back to SUMO trough TraCI. For these reasons I have decided to keep track of the signal plan internally within the class and increment the signal plan when necessary through TraCI.

The next function of the class is to ensure preemption is active at the requested time. Assume that at $t=0 \, \mathrm{s}$ the desired premption time $t_\mathrm{p}^*$ is received. This means, the green phase of the preemption sequence must start at the latest possible time $t_\mathrm{switch} \leq t_\mathrm{p}^*$. Given minimal signal lengths $l_\mathrm{min}$ and the requirement for transition phases (yellow signal before red) of a fixed length $l_\mathrm{trans}$ we can determine the earliest time $t_\mathrm{switch}$ using the simple Algorithm \ref{alg:t_switch}. The preemption sequence needs to be initiated at time $t$ if we compute that $t_\mathrm{switch}\left(t+\Delta t\right) > t_\mathrm{p}^*$. This requires \texttt{TrafficLight} to be able to compute the signal plan into the immediate future.


\begin{algorithm}[H]
\DontPrintSemicolon
$p \leftarrow$ default signal plan\;
$t \leftarrow$ initial time\;
$\Delta t \leftarrow$  time increment\;
$t_\mathrm{last} \leftarrow$ last signal phase increment time\;
$t_\mathrm{trans}=$ transition phase length\;
$found$=false\;
\While{not found}
{
	$phase=p\left(t\right)$\;
	\If{ not phase.isTranisition}
	{
		\If{$t_\mathrm{last} + phase.minDuration \leq t$ }
		{
			$found=$true
		}
	}
	$t:= t+\Delta t$
}
\KwResult{$t_\mathrm{switch}=t+t_\mathrm{trans}$}
\caption{Earliest guaranteed preemption time}
\label{alg:t_switch}
\end{algorithm}

Lastly, \texttt{TrafficLight} has the capability to compute the signal plan including the preemption sequence. This is simply done using the default plan up to $\mathrm{max}\left(t\right):\, t_\mathrm{switch}\left(t\right) \leq t_\mathrm{p}^*$ and then adding a transition state of length $l_\mathrm{trans}$ and green state downstream of the EV and a red state everywhere else for the rest of the desired signal sequence. Note, that a transition state does not necessarily mean a yellow signal. A transition phase state is determined according to the Table \ref{tab:transition}

\begin{table}[h]
\centering
\begin{tabular}{|c|c||c|c|} 
\cline{3-4}
\multicolumn{2}{l|}{}&\multicolumn{2}{c|}{to} \\ \cline{3-4}
\multicolumn{2}{l|}{}& green & red \\ \cline{3-4} \noalign{\vskip\doublerulesep \vskip-\arrayrulewidth}  \hline
\multirow{2}{*}{\rotatebox[origin=b]{90}{ from}}&green & green & yellow \\ \cline{2-4}
&red & red & red \\ \hline
\end{tabular}
\caption{Transition phase state table}
\label{tab:transition}
\end{table}

\subsection{Functionality of \texttt{Estimator}}
For the purposes of the validation of the proposed algorithm, I have implemented various methods of preemption corresponding to the following modes of operation of \texttt{Estimator}.
\begin{enumerate}
\item No preemption mode

In this mode of operation, \texttt{TrafficLight} only facilitates default traffic signal plan.

\item Polygon mode

Preemption is initialised at the earliest time possible after an EV sign-in. Which means $t_\mathrm{p}^*$ is always zero. 
\item Single computation mode

In the simulation step, when the \texttt{Scheduler} detects an EV sign-in, the proposed algorithm is used to compute the optimal preemption time $t_\mathrm{p}^*$. In order to do this \texttt{Estimator} requests signal plans with various preemption times $t_\mathrm{p}$  from \texttt{TrafficLight}. Since any supplied signal plan is feasible and optimal for a given $t_\mathrm{p}$ (meaning the preemption sequence starts at the latest possible time), \texttt{Estimator} has a guarantee of a feasible plan for simulations.


\item Recomputation mode

The optimal preemption time $t_\mathrm{p}^*$ is computed repeatedly for as long as \texttt{TrafficLight} can guarantee, that preemption will be in effect at the previously computed time, i.e., $t < t_\mathrm{switch}\left(t_\mathrm{last}\right)$ . The frequency of computation can be set to a desired value.

\item Short range mode

In case the sign-in distance is greater than the range of the lane area detectors, there can be virtual vehicles inserted between the EV and the end of the range of the detectors. These make use of the traffic flow density for each vehicle type used to inject vehicles into the simulation. It takes the time to reach the detector range
\begin{equation}
t_\mathrm{EV2DET} = \frac{d_\mathrm{EV} - l_\mathrm{DET}}{v_\mathrm{EV}},
\end{equation}
where $d_\mathrm{EV}$ is the distance of the EV to the detector, $l_\mathrm{DET}$ is the range of the detector and $v_\mathrm{EV}$ is the speed of the EV. 

Then, given the probability $p_\mathrm{type}$ that a vehicle of a given type enters the simulation within a given second (which is known due to the fact, that this information is used for injecting vehicles into the scenario), we can compute the estimated number of vehicles of the given type $n_\mathrm{type} = \mathrm{ceil}\left( p_\mathrm{type}*t_\mathrm{ev2det} \right)$ between the end of the detection range and the EV, where $\mathrm{ceil}()$ equates to rounding up. This rounding is done to minimise the chance of an optimistic estimate, which could lead to unnecessarily delaying the EV. This is only due to a subjective preference of delaying surrounding traffic over delaying the EV.

Lastly while alternating between vehicle types vehicles are placed between the end of detector range and the EV, until there are $n_\mathrm{type}$ vehicles of each vehicle type. Then they are equidistantly spread over this region and are given initial velocities taken from linear interpolation of velocities of the EV and the furthest vehicle in detector range. The optimization part of the proposed algorithm then includes these virtual vehicles. 

It should be noted, that this estimation procedure is quite elementary and there exist plethora of more sophisticated techniques. I used this method mainly because the traffic flow density estimation is not the focus of this thesis and also it seemed excessive to do otherwise, given the fact, I already had the required values available.

\end{enumerate}

\section{Simulation experiments}
To validate the proposed method I have run the scenario using various settings. The values I gathered from each were average halt times of the surrounding traffic and the EVs themselves as well. To be considered affected by the passage of the EV a vehicle had to fulfil the condition of there being such a time instance when the vehicle is on its way to the intersection and simultaneously the EV has signed-in but not yet cleared the intersection. This allows me to fairly compare different preemption methods, even though for some methods, vehicles which are not affected by the EV fulfil this condition.

Each test consists of 30 simulations where in each the injection time of the EV is incrmented by $3\, \mathrm{s}$ thus covering the whole $90 \, \mathrm{s}$ of the default signal plan length. The earliest injection of an EV happens at $t=300 \, \mathrm{s}$, to allow the simulation to approach steady state. The set of 30 simulations is repeated  total of 30 times using a different seed for the pseudorandom number generator uses to plan vehicle injection times. Thus getting a different distribution of vehicles for each set. This totals to 900 individual simulations for each tested setting. In all of the tests the EV enters from the west and leaves to the east. 

For the purpose of the tests I defined the used traffic flow densities for the vehicle types as shown in Table \ref{tab:density}

\begin{table}[h]
\centering
\begin{tabular}{|c|c|c|c|}
\cline{2-4}
\multicolumn{1}{l|}{}&\multicolumn{3}{c|}{vehicles per hour} \\  \cline{2-4}
\multicolumn{1}{l|}{}& LIGHT & MODERATE & HEAVY \\ \hline
passenger&1500&2250&3000 \\ \hline
bus&60&75&90 \\ \hline
\end{tabular}
\caption{Definition of used traffic flow densities.}
\label{tab:density}
\end{table}

\subsection{Preemption trigger distance for polygon method}
To be able to compare the proposed method to the more traditional static polygon approach, we need to find the optimal polygon size for all the used traffic flow densities. In Table \ref{tab:polygon_speed}, we can see how the size of the polygon in the direction of the approach of the EV ( trigger distance ) combined with different traffic flow densities affects median minimum velocity to which an EV is forced to slow down, this is analogous to $V_\mathrm{min}^0$ from equation \ref{eq:vstar}. In the table, the optimal values for individual traffic flow densities are \textcolor{magenta}{highlighted}. In the rest of the thesis, whenever a polygon method with a given traffic flow density is used, the corresponding optimal trigger distance will be used.

\begin{table}[h]
\centering
\begin{tabular}{|c|c||c|c|c|}
\cline{2-5}
\multicolumn{1}{l|}{}&veh/hour&LIGHT&MODERATE&HEAVY \\ \cline{2-5} 
\noalign{\vskip\doublerulesep \vskip-\arrayrulewidth} \hline 
\multirow{8}{*}{\rotatebox[origin=c]{90}{ trigger distance}} &100 m & 6.68 & 4.97 & 0.20 \\ \cline{2-5}
&200 m & 13.41 & 9.07 & 2.59 \\ \cline{2-5}
&300 m & \textcolor{magenta}{13.92} & 12.98 & 3.77 \\ \cline{2-5}
&400 m & 13.90 & \textcolor{magenta}{13.50} & 5.59 \\ \cline{2-5}
&500 m & 13.90& 13.58 & 8.95 \\ \cline{2-5}
&600 m & 13.90& 13.59 & 11.01 \\ \cline{2-5}
&700 m & 13.90& 13.59 & \textcolor{magenta}{13.33} \\ \cline{2-5}
&800 m & 13.90& 13.59 & 13.33 \\ \hline
\end{tabular}
\caption{Median values of the slowest speeds $\left[ \mathrm{ms^{-1}} \right]$ achieved by EVs.}
\label{tab:polygon_speed}
\end{table}

\subsection{Performance comparison between preemption methods}
To compare the performance of individual methods I have used the MODERATE traffic flow density setting and a sign-in distance of $400\, \mathrm{m}$. Figure \ref{fig:methods_mid} shows a box chart containing the halt times of an average vehicle influenced by the passage of the EV.


\begin{figure}[h]
\centering
\includegraphics[width=\linewidth]{METHODS_MOD_VEH.pdf}
\caption{Average halt times of affected vehicles using different modes.}
\label{fig:methods_mid}
\end{figure}

\begin{figure}
\centering
\includegraphics[width=\linewidth]{METHODS_MOD_SPEED.pdf}
\caption{Minimum EV velocities $V_\mathrm{min}$.}
\label{fig:methods_mid_speed}
\end{figure}

At first it may seem, that using no preemption has definitely the least impact on the surrounding traffic. This result is, however, the least accurate of all the methods, since SUMO does not currently support realistic behaviour of vehicles in proximity to the EV as stated at the beginning of Chapter \ref{SUMO}. The other methods minimize the interaction between the EV and other vehicles and thus, this shortcoming of SUMO has a smaller impact on the result in those cases. The median values from Figure \ref{fig:methods_mid} can be seen in Table \ref{tab:results1}.

While the impact of the EV on surrounding traffic can be inaccurately simulated by SUMO, the opposite is not the case. Vehicles take time to form a virtual middle lane and do not break the rules of traffic to move out of the way. Thus, measuring the lowest speed $V_\mathrm{min}$, to which the EV is forced to slow down, can be used to represent this influence.

Furthermore, since the main goal of premption is to shorten the response times of EVs and make their passage safer, even if SUMO could simulate the impact the EV has on an intersection more accurately, the impact an intersection without preemption has on the EV cannot be justified, as seen in Figure \ref{fig:methods_mid_speed}. We can see that without preemption the median slowdown is very significant, while for all the investigated methods of preemption these values are comparable.

\begin{table}
\centering
\begin{tabular}{|c||c|c|c|c|}
\hline
method&none&polygon&$t_\mathrm{p}^*$ computation&$t_\mathrm{p}^*$ recomputation \\ \hline
time [s]&29.24 & 23.41 & 33.25 & 33.13 \\ \hline
\end{tabular}
\caption{median halt time of an average vehicle for different preemption methods}
\label{tab:results1}
\end{table}

\subsection{Influence of sign-in distance}
For this series of tests, I investigate the impact of the distance from which an EV sends its sign-in signal to initiate the given preemption method.  I compare the proposed method with the static polygon approach. For the polygon the preemption distance is set to its optimal one as per Table \ref{tab:density}. The traffic flow density setting used is MODERATE. The investigated distances are 200, 500 and 800 m. The results can be seen in Figures \ref{fig:dist_speed} and \ref{fig:dist_veh}.

\begin{figure}
\centering
\includegraphics[width=\linewidth]{DISTS_SPEED.pdf}
\caption{Effect of diffrent sign-in distances and preemption methods on the minimum EV speed}
\label{fig:dist_speed}
\end{figure}

\begin{figure}
\centering
\includegraphics[width=\linewidth]{DISTS_VEH.pdf}
\caption{Effect of diffrent sign-in distances and preemption methods on the average halt times}
\label{fig:dist_veh}
\end{figure}

From the results it can be seen, that the proposed method should should have a sign-in distance at least identical to the polygon-based method. Lower distances do not give the algorithm enough flexibility to allow for optimal preemption. As for longer distances, the single computation variation of the proposed algorithm does lose its accuracy with the rising sign-in distance, Therefore, if it were to be implemented in real world the sign in distance would need to be adjusted to best perform on a given intersection.

The recomputation version of the algorithm does perform the best of all the investigated options and with higher sign-in distances it has more time to reevaluate the optimal time of preemption. Thus, if it were to be implemented in the real world, the sign-in distance should be set to the longest possible. 

\subsection{Influence of traffic flow density}
This series of tests shows how the single computation and heavy computation handle changing traffic flow density and if there is any need for manual adjustment of the methods. The sign-in distance in all tests is set to 800 m. As seen in Figures \ref{fig:density_speed} and \ref{fig:density_veh}, there is little to no difference between the average halt times, thus the recomputation  only helps with lowering passage times of the EVs when higher traffic flow densities are encountered.

\begin{figure}
\centering
\includegraphics[width=\linewidth]{DENSITY_SPEED.pdf}
\caption{Comparison of the effect diffrent traffic flow densities have on the minimum EV speed}
\label{fig:density_speed}
\end{figure}

\begin{figure}
\centering
\includegraphics[width=\linewidth]{DENSITY_VEH.pdf}
\caption{Comparison of the effect diffrent traffic flow densities have on the average vehicle halt time}
\label{fig:density_veh}
\end{figure}

\subsection{Viability of short detector ranges}
In this last series of test I aim to show whether the proposed method can be used in scenarios where the detector range is limited, but the sign-in distance is greater. This could be interpreted as a situation where the data is collected using computer vision with cameras placed around the intersection, but not too far from it. This is the implementation most likely to be implemented using current technologies and thus could be the first testable version of the algorithm.

All tests have a sign-in distance of 400 m, the traffic flow density is set to MODERATE and the range of the lane area detectors is limited to 100 m, thus the algorithm needs to make virtual vehicles to fill the unobserved area ahead of the EV. The results, labeled SHORT, are compared to the previous results, labeled LONG, where the detector range was unlimited and the static polygon generated results.

\begin{figure}
\centering
\includegraphics[width=\linewidth]{VIRT_SPEED.pdf}
\caption{Short detector range effect on the minimum EV speed.}
\label{fig:virt_speed}
\end{figure}

\begin{figure}
\centering
\includegraphics[width=\linewidth]{VIRT_VEH.pdf}
\caption{Short detector range effect on the average vehicle halt time.}
\label{fig:virt_veh}
\end{figure}

The Figures \ref{fig:virt_speed} and \ref{fig:virt_veh} show there is no decrement in the minimum speed EVs reach form the LONG variant and the impact on surrounding traffic due to the passage of EVs does not increase significantly and still performs better than the static polygon approach. It should be noted, however, that the polygon happens to have the preemption distance fine-tuned to the traffic flow density, and therefore, the result is likely closer to an adaptive polygon implementation. 

Given the fact, that the recomputation version of the algorithm has been shown to perform best, when large sign-in distances are used. As a last experiment I decided to repeat the previous tests with different values. The results shown in Figures  \ref{fig:virt_speed_800} and \ref{fig:virt_veh_800} show that the proposed method is in this scenario comparable to a dynamic (400 m) polygon preemption method, the static (800 m) polygon method fares significantly worse.  The results show that the median halt time of an average vehicle is still below that of any of the polygon methods tested. The variance is quite large, however. I believe this could be mitigated through better estimates on the number of vehicles between the end of the detector range and the EV This estimate could be entirely eliminated through the use of V2X communication. On the other hand, it is quite difficult to argue for the communication not being used to give precise location and speed information.

\begin{figure}
\centering
\includegraphics[width=\linewidth]{VIRT_SPEED_800.pdf}
\caption{Short detector range effect on the minimum EV speed with sign-in at 800 m.}
\label{fig:virt_speed_800}
\end{figure}

\begin{figure}
\centering
\includegraphics[width=\linewidth]{VIRT_VEH_800.pdf}
\caption{Short detector range effect on the average vehicle halt time with sign-in at 800 m.}
\label{fig:virt_veh_800}
\end{figure}

\chapter{Conclusion}
\label{conclusion}
In conclusion, this thesis focused on the development of new traffic light preemption techniques for emergency vehicle prioritization at traffic light junctions.

In Chapter \ref{intro}, I have introduced the motivations behind traffic light preemption, its advantages and its shortcomings. I have give a summary of existing approaches and discussed their individual strengths and weaknesses. Furthermore, I have given a short outline of this thesis.

In Chapter \ref{model}, I have investigated car-following models, explained how they work and when they are useful. Next, I have done an analysis of the accuracy of several car-following models at intersections, namely IDM and IIDM, I also proposed a linear queue discharge model, which has shown to be surprisingly accurate in simulating the positions of vehicles in a queue at a traffic light.

When it comes to IDM and IIDM, I showed that the commonly used IDM is unnecessarily inaccurate in modelling velocities of vehicles going through an intersection, and that its improved version is much better at this task. I selected IIDM as the model for simulation of vehicle platoons going through a traffic light controlled intersection for the remainder of my work.

In Chapter \ref{algorithm}, I proposed a new time optimal traffic signal preemption algorithm which utilizes the potential of modern traffic data gathering technology. The method is built upon several assumptions, namely, knowing accurate positions and speeds of vehicles, having good estimates on the car-following model parameters of these vehicles, and having complete information about the traffic signal phase plan, including alternative plans containing preemption sequences, for the duration of passage of the emergency vehicle.

Furthermore, I have discussed how the aforementioned assumptions can be satisfied in the real world and offered an adaptation of the method for situations, where the range of vehicle localization devices is limited.

In Chapter \ref{SUMO}, I used the traffic simulator SUMO to validate the developed method. I have explained, how the simulation scenario was created and how the method was implemented through a communication interface TraCI, using Python programming language. Next I designed multiple tests to show the performance of the method compared to the most widespread method of traffic signal preemption, namely, lane area triggered preemption.

The results show that the developed method surpasses the traditional approaches in every practical case except for complexity. Specifically, it ensures the emergency vehicle passes the intersection with minimum delay and maximum safety, while also minimizes the potential impact on surrounding traffic. The method delays the preemption sequence initialization to the latest possible instance, which still enables the emergency vehicle minimum delay.

The alternative method for cases where detection devices have limited range, has also been verified, It, understandably, performs worse than the unlimited method, but I haven't been able to show it performing worse than the commonly used approach. The overall performance was more significantly influenced by various specific traffic conditions present in the scenario.

Lastly, I want to suggest a direction for future research. Given the fact, that the alternative, limited, method is technologically more accessible, I suggest to find a more advanced method for filling the dead zone between the emergency vehicle and the end of the range of vehicle detectors with virtual vehicles for the purposes of simulation. 

On a similar note, the method could be, potentially, enriched with a lane changing model. As it stands, the method does not simulate overtaking, something emergency vehicles do quite often. Should the method  have the capability to accurately simulate the sometimes aggressive manoeuvres emergency vehicles make, I suspect the resulting method could have major impact on city traffic. The implementation, in that case, should not be done as crudely as I demonstrated. And instead, should be implemented directly into a popular traffic simulator, such as SUMO, which in turn would be used to simulate real traffic for the purpose of evaluating the cost function of the algorithm.
Contributing to the SUMO project is something I wish I had time to do simultaneously with the work described in this thesis.

\printbibliography

\ctutemplate{specification.as.chapter}

\end{document}
